export type { Color } from './color';
export type { ColorPickerProps } from './ColorPicker';
declare const _default: {
    new (...args: any[]): {
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            onChange: (value: import("./color").Color, hex: string) => void;
            value: string | import("./color").Color;
            defaultValue: string | import("./color").Color;
            getPopupContainer: (triggerNode: HTMLElement) => HTMLElement;
            trigger: import("./interface").TriggerType;
            format: "hex" | "rgb" | "hsb";
            allowClear: boolean;
            panelRender: import("./ColorPickerPanel").PanelRender;
            onOpenChange: (open: boolean) => void;
            placement: import("./interface").TriggerPlacement;
            arrow: boolean | {
                pointAtCenter: boolean;
            };
            autoAdjustOverflow: boolean;
            onChangeComplete: (value: import("./color").Color) => void;
            formatOptions: ("hex" | "rgb" | "hsb")[];
            presets: import("./interface").PresetsItem[];
            styles: {};
            rootClassName: string;
            onFormatChange: (format: import("./interface").ColorFormat) => void;
            showText: boolean | ((color: import("./color").Color) => import("../_util/type").VueNode);
        }> & Omit<Readonly<import("vue").ExtractPropTypes<{
            value: {
                type: import("vue").PropType<string | import("./color").Color>;
                default: any;
            };
            defaultValue: {
                type: import("vue").PropType<string | import("./color").Color>;
                default: string;
            };
            open: import("vue-types").VueTypeValidableDef<boolean>;
            disabled: import("vue-types").VueTypeValidableDef<boolean>;
            placement: {
                type: import("vue").PropType<import("./interface").TriggerPlacement>;
                default: string;
            };
            trigger: {
                type: import("vue").PropType<import("./interface").TriggerType>;
                default: string;
            };
            format: {
                type: import("vue").PropType<"hex" | "rgb" | "hsb">;
                default: string;
            };
            formatOptions: {
                type: import("vue").PropType<("hex" | "rgb" | "hsb")[]>;
                default: any;
            };
            allowClear: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            presets: {
                type: import("vue").PropType<import("./interface").PresetsItem[]>;
                default: any;
            };
            arrow: {
                type: import("vue").PropType<boolean | {
                    pointAtCenter: boolean;
                }>;
                default: boolean;
            };
            styles: {
                type: import("vue").PropType<{
                    popup?: import("vue").CSSProperties;
                    popupOverlayInner?: StyleSheet;
                }>;
                default: () => {};
            };
            rootClassName: import("vue-types").VueTypeValidableDef<string> & {
                default: string;
            };
            onOpenChange: {
                type: import("vue").PropType<(open: boolean) => void>;
                default: () => void;
            };
            onFormatChange: {
                type: import("vue").PropType<(format: import("./interface").ColorFormat) => void>;
                default: () => void;
            };
            onChange: {
                type: import("vue").PropType<(value: import("./color").Color, hex: string) => void>;
                default: () => void;
            };
            getPopupContainer: {
                type: import("vue").PropType<(triggerNode: HTMLElement) => HTMLElement>;
                default: any;
            };
            autoAdjustOverflow: {
                type: import("vue").PropType<boolean | import("../tooltip").AdjustOverflow>;
                default: boolean;
            };
            onChangeComplete: {
                type: import("vue").PropType<(value: import("./color").Color) => void>;
                default: () => void;
            };
            showText: {
                type: import("vue").PropType<boolean | ((color: import("./color").Color) => import("../_util/type").VueNode)>;
                default: boolean;
            };
            size: import("vue-types").VueTypeDef<string>;
            destroyTooltipOnHide: import("vue-types").VueTypeValidableDef<boolean>;
            panelRender: {
                type: import("vue").PropType<import("./ColorPickerPanel").PanelRender>;
                default: any;
            };
        }>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "onChange" | "value" | "defaultValue" | "getPopupContainer" | "trigger" | "format" | "allowClear" | "panelRender" | "onOpenChange" | "placement" | "arrow" | "autoAdjustOverflow" | "onChangeComplete" | "formatOptions" | "presets" | "styles" | "rootClassName" | "onFormatChange" | "showText">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            value: {
                type: import("vue").PropType<string | import("./color").Color>;
                default: any;
            };
            defaultValue: {
                type: import("vue").PropType<string | import("./color").Color>;
                default: string;
            };
            open: import("vue-types").VueTypeValidableDef<boolean>;
            disabled: import("vue-types").VueTypeValidableDef<boolean>;
            placement: {
                type: import("vue").PropType<import("./interface").TriggerPlacement>;
                default: string;
            };
            trigger: {
                type: import("vue").PropType<import("./interface").TriggerType>;
                default: string;
            };
            format: {
                type: import("vue").PropType<"hex" | "rgb" | "hsb">;
                default: string;
            };
            formatOptions: {
                type: import("vue").PropType<("hex" | "rgb" | "hsb")[]>;
                default: any;
            };
            allowClear: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            presets: {
                type: import("vue").PropType<import("./interface").PresetsItem[]>;
                default: any;
            };
            arrow: {
                type: import("vue").PropType<boolean | {
                    pointAtCenter: boolean;
                }>;
                default: boolean;
            };
            styles: {
                type: import("vue").PropType<{
                    popup?: import("vue").CSSProperties;
                    popupOverlayInner?: StyleSheet;
                }>;
                default: () => {};
            };
            rootClassName: import("vue-types").VueTypeValidableDef<string> & {
                default: string;
            };
            onOpenChange: {
                type: import("vue").PropType<(open: boolean) => void>;
                default: () => void;
            };
            onFormatChange: {
                type: import("vue").PropType<(format: import("./interface").ColorFormat) => void>;
                default: () => void;
            };
            onChange: {
                type: import("vue").PropType<(value: import("./color").Color, hex: string) => void>;
                default: () => void;
            };
            getPopupContainer: {
                type: import("vue").PropType<(triggerNode: HTMLElement) => HTMLElement>;
                default: any;
            };
            autoAdjustOverflow: {
                type: import("vue").PropType<boolean | import("../tooltip").AdjustOverflow>;
                default: boolean;
            };
            onChangeComplete: {
                type: import("vue").PropType<(value: import("./color").Color) => void>;
                default: () => void;
            };
            showText: {
                type: import("vue").PropType<boolean | ((color: import("./color").Color) => import("../_util/type").VueNode)>;
                default: boolean;
            };
            size: import("vue-types").VueTypeDef<string>;
            destroyTooltipOnHide: import("vue-types").VueTypeValidableDef<boolean>;
            panelRender: {
                type: import("vue").PropType<import("./ColorPickerPanel").PanelRender>;
                default: any;
            };
        }>>, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
            onChange: (value: import("./color").Color, hex: string) => void;
            value: string | import("./color").Color;
            defaultValue: string | import("./color").Color;
            getPopupContainer: (triggerNode: HTMLElement) => HTMLElement;
            trigger: import("./interface").TriggerType;
            format: "hex" | "rgb" | "hsb";
            allowClear: boolean;
            panelRender: import("./ColorPickerPanel").PanelRender;
            onOpenChange: (open: boolean) => void;
            placement: import("./interface").TriggerPlacement;
            arrow: boolean | {
                pointAtCenter: boolean;
            };
            autoAdjustOverflow: boolean;
            onChangeComplete: (value: import("./color").Color) => void;
            formatOptions: ("hex" | "rgb" | "hsb")[];
            presets: import("./interface").PresetsItem[];
            styles: {};
            rootClassName: string;
            onFormatChange: (format: import("./interface").ColorFormat) => void;
            showText: boolean | ((color: import("./color").Color) => import("../_util/type").VueNode);
        }, {}, string> & {
            beforeCreate?: (() => void) | (() => void)[];
            created?: (() => void) | (() => void)[];
            beforeMount?: (() => void) | (() => void)[];
            mounted?: (() => void) | (() => void)[];
            beforeUpdate?: (() => void) | (() => void)[];
            updated?: (() => void) | (() => void)[];
            activated?: (() => void) | (() => void)[];
            deactivated?: (() => void) | (() => void)[];
            beforeDestroy?: (() => void) | (() => void)[];
            beforeUnmount?: (() => void) | (() => void)[];
            destroyed?: (() => void) | (() => void)[];
            unmounted?: (() => void) | (() => void)[];
            renderTracked?: ((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[];
            renderTriggered?: ((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[];
            errorCaptured?: ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>, info: string) => boolean | void)[];
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean>): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<{
        value: {
            type: import("vue").PropType<string | import("./color").Color>;
            default: any;
        };
        defaultValue: {
            type: import("vue").PropType<string | import("./color").Color>;
            default: string;
        };
        open: import("vue-types").VueTypeValidableDef<boolean>;
        disabled: import("vue-types").VueTypeValidableDef<boolean>;
        placement: {
            type: import("vue").PropType<import("./interface").TriggerPlacement>;
            default: string;
        };
        trigger: {
            type: import("vue").PropType<import("./interface").TriggerType>;
            default: string;
        };
        format: {
            type: import("vue").PropType<"hex" | "rgb" | "hsb">;
            default: string;
        };
        formatOptions: {
            type: import("vue").PropType<("hex" | "rgb" | "hsb")[]>;
            default: any;
        };
        allowClear: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        presets: {
            type: import("vue").PropType<import("./interface").PresetsItem[]>;
            default: any;
        };
        arrow: {
            type: import("vue").PropType<boolean | {
                pointAtCenter: boolean;
            }>;
            default: boolean;
        };
        styles: {
            type: import("vue").PropType<{
                popup?: import("vue").CSSProperties;
                popupOverlayInner?: StyleSheet;
            }>;
            default: () => {};
        };
        rootClassName: import("vue-types").VueTypeValidableDef<string> & {
            default: string;
        };
        onOpenChange: {
            type: import("vue").PropType<(open: boolean) => void>;
            default: () => void;
        };
        onFormatChange: {
            type: import("vue").PropType<(format: import("./interface").ColorFormat) => void>;
            default: () => void;
        };
        onChange: {
            type: import("vue").PropType<(value: import("./color").Color, hex: string) => void>;
            default: () => void;
        };
        getPopupContainer: {
            type: import("vue").PropType<(triggerNode: HTMLElement) => HTMLElement>;
            default: any;
        };
        autoAdjustOverflow: {
            type: import("vue").PropType<boolean | import("../tooltip").AdjustOverflow>;
            default: boolean;
        };
        onChangeComplete: {
            type: import("vue").PropType<(value: import("./color").Color) => void>;
            default: () => void;
        };
        showText: {
            type: import("vue").PropType<boolean | ((color: import("./color").Color) => import("../_util/type").VueNode)>;
            default: boolean;
        };
        size: import("vue-types").VueTypeDef<string>;
        destroyTooltipOnHide: import("vue-types").VueTypeValidableDef<boolean>;
        panelRender: {
            type: import("vue").PropType<import("./ColorPickerPanel").PanelRender>;
            default: any;
        };
    }>> & import("vue").ShallowUnwrapRef<() => JSX.Element> & {} & import("vue").ComponentCustomProperties & {};
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
} & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
    value: {
        type: import("vue").PropType<string | import("./color").Color>;
        default: any;
    };
    defaultValue: {
        type: import("vue").PropType<string | import("./color").Color>;
        default: string;
    };
    open: import("vue-types").VueTypeValidableDef<boolean>;
    disabled: import("vue-types").VueTypeValidableDef<boolean>;
    placement: {
        type: import("vue").PropType<import("./interface").TriggerPlacement>;
        default: string;
    };
    trigger: {
        type: import("vue").PropType<import("./interface").TriggerType>;
        default: string;
    };
    format: {
        type: import("vue").PropType<"hex" | "rgb" | "hsb">;
        default: string;
    };
    formatOptions: {
        type: import("vue").PropType<("hex" | "rgb" | "hsb")[]>;
        default: any;
    };
    allowClear: {
        type: import("vue").PropType<boolean>;
        default: boolean;
    };
    presets: {
        type: import("vue").PropType<import("./interface").PresetsItem[]>;
        default: any;
    };
    arrow: {
        type: import("vue").PropType<boolean | {
            pointAtCenter: boolean;
        }>;
        default: boolean;
    };
    styles: {
        type: import("vue").PropType<{
            popup?: import("vue").CSSProperties;
            popupOverlayInner?: StyleSheet;
        }>;
        default: () => {};
    };
    rootClassName: import("vue-types").VueTypeValidableDef<string> & {
        default: string;
    };
    onOpenChange: {
        type: import("vue").PropType<(open: boolean) => void>;
        default: () => void;
    };
    onFormatChange: {
        type: import("vue").PropType<(format: import("./interface").ColorFormat) => void>;
        default: () => void;
    };
    onChange: {
        type: import("vue").PropType<(value: import("./color").Color, hex: string) => void>;
        default: () => void;
    };
    getPopupContainer: {
        type: import("vue").PropType<(triggerNode: HTMLElement) => HTMLElement>;
        default: any;
    };
    autoAdjustOverflow: {
        type: import("vue").PropType<boolean | import("../tooltip").AdjustOverflow>;
        default: boolean;
    };
    onChangeComplete: {
        type: import("vue").PropType<(value: import("./color").Color) => void>;
        default: () => void;
    };
    showText: {
        type: import("vue").PropType<boolean | ((color: import("./color").Color) => import("../_util/type").VueNode)>;
        default: boolean;
    };
    size: import("vue-types").VueTypeDef<string>;
    destroyTooltipOnHide: import("vue-types").VueTypeValidableDef<boolean>;
    panelRender: {
        type: import("vue").PropType<import("./ColorPickerPanel").PanelRender>;
        default: any;
    };
}>>, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    onChange: (value: import("./color").Color, hex: string) => void;
    value: string | import("./color").Color;
    defaultValue: string | import("./color").Color;
    getPopupContainer: (triggerNode: HTMLElement) => HTMLElement;
    trigger: import("./interface").TriggerType;
    format: "hex" | "rgb" | "hsb";
    allowClear: boolean;
    panelRender: import("./ColorPickerPanel").PanelRender;
    onOpenChange: (open: boolean) => void;
    placement: import("./interface").TriggerPlacement;
    arrow: boolean | {
        pointAtCenter: boolean;
    };
    autoAdjustOverflow: boolean;
    onChangeComplete: (value: import("./color").Color) => void;
    formatOptions: ("hex" | "rgb" | "hsb")[];
    presets: import("./interface").PresetsItem[];
    styles: {};
    rootClassName: string;
    onFormatChange: (format: import("./interface").ColorFormat) => void;
    showText: boolean | ((color: import("./color").Color) => import("../_util/type").VueNode);
}, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & import("@vue/runtime-core").Plugin;
export default _default;
