import { PropType } from 'vue';
import { PreviewProps } from './Preview';
export interface PreviewOperationsProps extends Pick<PreviewProps, 'onClose' | 'prefixCls'> {
    onRotateRight?: () => void;
    onRotateLeft?: () => void;
    onScaleSelect?: (value: number) => void;
    onRotateSave?: () => void;
    onZoomIn?: () => void;
    onZoomOut?: () => void;
    onSwitchLeft?: () => void;
    onSwitchRight?: () => void;
    rotateSaveDisabled?: boolean;
    isGroup?: boolean;
    groupCount?: number;
    currentIndex?: number;
}
export declare const previewOperationsProps: {
    prefixCls: StringConstructor;
    onClose: PropType<(e: MouseEvent | KeyboardEvent) => void>;
    onRotateRight: PropType<() => void>;
    onRotateLeft: PropType<() => void>;
    onScaleSelect: PropType<(value: number) => void>;
    onRotateSave: PropType<() => void>;
    onZoomIn: PropType<() => void>;
    onZoomOut: PropType<() => void>;
    onSwitchLeft: PropType<() => void>;
    onSwitchRight: PropType<() => void>;
    rotateSaveDisabled: BooleanConstructor;
    isGroup: BooleanConstructor;
    groupCount: NumberConstructor;
    currentIndex: NumberConstructor;
};
declare const PreviewOperations: import("vue").DefineComponent<{
    prefixCls: StringConstructor;
    onClose: PropType<(e: MouseEvent | KeyboardEvent) => void>;
    onRotateRight: PropType<() => void>;
    onRotateLeft: PropType<() => void>;
    onScaleSelect: PropType<(value: number) => void>;
    onRotateSave: PropType<() => void>;
    onZoomIn: PropType<() => void>;
    onZoomOut: PropType<() => void>;
    onSwitchLeft: PropType<() => void>;
    onSwitchRight: PropType<() => void>;
    rotateSaveDisabled: BooleanConstructor;
    isGroup: BooleanConstructor;
    groupCount: NumberConstructor;
    currentIndex: NumberConstructor;
}, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    prefixCls: StringConstructor;
    onClose: PropType<(e: MouseEvent | KeyboardEvent) => void>;
    onRotateRight: PropType<() => void>;
    onRotateLeft: PropType<() => void>;
    onScaleSelect: PropType<(value: number) => void>;
    onRotateSave: PropType<() => void>;
    onZoomIn: PropType<() => void>;
    onZoomOut: PropType<() => void>;
    onSwitchLeft: PropType<() => void>;
    onSwitchRight: PropType<() => void>;
    rotateSaveDisabled: BooleanConstructor;
    isGroup: BooleanConstructor;
    groupCount: NumberConstructor;
    currentIndex: NumberConstructor;
}>>, {
    isGroup: boolean;
    rotateSaveDisabled: boolean;
}>;
export default PreviewOperations;
