import type { PropType } from 'vue';
import type { DisabledTime, DisabledTimes, PanelMode, PickerMode } from '../vc-picker/interface';
import { RangeType } from '../vc-picker/RangePicker';
import type { VueNode } from '../_util/type';
export declare type Config = {
    name: string;
    type: string;
    formate: string;
    span?: string;
    defaultVal?: string;
    choice?: string;
};
declare const _default: {
    new (...args: any[]): {
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            open: boolean;
            autofocus: boolean;
            showTime: any;
            showNow: boolean;
            focusValue: boolean;
            showToday: boolean;
            allowClear: boolean;
            defaultOpen: boolean;
            inputReadOnly: boolean;
            bordered: boolean;
        }> & Omit<Readonly<import("vue").ExtractPropTypes<{
            defaultPickerValue: {
                type: PropType<any>;
            };
            defaultValue: {
                type: PropType<any>;
            };
            value: {
                type: PropType<any>;
            };
            disabledTime: {
                type: PropType<DisabledTime<any> & ((date: any, type: RangeType) => DisabledTimes)>;
            };
            format: {
                type: PropType<string | import("../vc-picker/interface").CustomFormat<any> | (string | import("../vc-picker/interface").CustomFormat<any>)[]>;
            };
            renderExtraFooter: {
                type: PropType<((mode: PanelMode) => VueNode) & (() => VueNode)>;
            };
            onChange: {
                type: PropType<((value: any, dateString: string) => void) & ((value: [any, any] | [string, string], dateString: [string, string]) => void)>;
            };
            'onUpdate:value': {
                type: PropType<((value: any) => void) & ((value: [any, any] | [string, string]) => void)>;
            };
            onOk: {
                type: PropType<((value: any) => void) & ((dates: [any, any] | [string, string]) => void)>;
            };
            code: StringConstructor;
            hisUuid: StringConstructor;
            domain: StringConstructor;
            config: PropType<Config>;
            onConfigChange: PropType<(config: Config) => void>;
            'onUpdate:configValue': PropType<(config: Config) => void>;
            pickerClassName: StringConstructor;
            allowEmpty: {
                type: PropType<[boolean, boolean]>;
            };
            dateRender: {
                type: PropType<import("../vc-picker/RangePicker").RangeDateRender<unknown>>;
            };
            disabled: {
                type: PropType<boolean | [boolean, boolean]>;
            };
            separator: {
                type: StringConstructor;
            };
            ranges: {
                type: PropType<Record<string, [unknown, unknown] | (() => [unknown, unknown])>>;
            };
            placeholder: ArrayConstructor;
            mode: {
                type: PropType<[PanelMode, PanelMode]>;
            };
            onCalendarChange: {
                type: PropType<(values: [string, string] | [unknown, unknown], formatString: [string, string], info: import("../vc-picker/RangePicker").RangeInfo) => void>;
            };
            onPanelChange: {
                type: PropType<(values: [string, string] | [unknown, unknown], modes: [PanelMode, PanelMode]) => void>;
            };
            showNow: {
                type: BooleanConstructor;
                default: any;
            };
            monthCellRender: {
                type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
            };
            monthCellContentRender: {
                type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
            };
            id: StringConstructor;
            dropdownClassName: StringConstructor;
            dropdownAlign: {
                type: PropType<import("../vc-align/interface").AlignType>;
            };
            popupStyle: {
                type: PropType<import("vue").CSSProperties>;
            };
            transitionName: StringConstructor;
            allowClear: {
                type: BooleanConstructor;
                default: any;
            };
            autofocus: {
                type: BooleanConstructor;
                default: any;
            };
            focusValue: {
                type: BooleanConstructor;
                default: any;
            };
            tabindex: NumberConstructor;
            open: {
                type: BooleanConstructor;
                default: any;
            };
            defaultOpen: {
                type: BooleanConstructor;
                default: any;
            };
            inputReadOnly: {
                type: BooleanConstructor;
                default: any;
            };
            getPopupContainer: {
                type: PropType<(node: HTMLElement) => HTMLElement>;
            };
            panelRender: {
                type: PropType<(originPanel: VueNode) => VueNode>;
            };
            onOpenChange: {
                type: PropType<(open: boolean) => void>;
            };
            'onUpdate:open': {
                type: PropType<(open: boolean) => void>;
            };
            onFocus: {
                type: PropType<import("../_util/EventInterface").FocusEventHandler>;
            };
            onBlur: {
                type: PropType<import("../_util/EventInterface").FocusEventHandler>;
            };
            onMousedown: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseup: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseenter: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseleave: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onClick: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onContextmenu: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onKeydown: {
                type: PropType<(event: KeyboardEvent, preventDefault: () => void) => void>;
            };
            role: StringConstructor;
            name: StringConstructor;
            autocomplete: StringConstructor;
            direction: {
                type: PropType<"ltr" | "rtl">;
            };
            showToday: {
                type: BooleanConstructor;
                default: any;
            };
            showTime: {
                type: PropType<boolean | import("../vc-picker/panels/TimePanel").SharedTimeProps<any>>;
                default: any;
            };
            locale: {
                type: PropType<import("../date-picker/generatePicker").PickerLocale>;
            };
            size: {
                type: PropType<import("../config-provider").SizeType>;
            };
            bordered: {
                type: BooleanConstructor;
                default: any;
            };
            disabledDate: {
                type: PropType<(date: any) => boolean>;
            };
            picker: {
                type: PropType<PickerMode>;
            };
            valueFormat: StringConstructor;
            disabledHours: PropType<() => number[]>;
            disabledMinutes: PropType<(hour: number) => number[]>;
            disabledSeconds: PropType<(hour: number, minute: number) => number[]>;
        }>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "open" | "autofocus" | "showTime" | "showNow" | "focusValue" | "showToday" | "allowClear" | "defaultOpen" | "inputReadOnly" | "bordered">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            defaultPickerValue: {
                type: PropType<any>;
            };
            defaultValue: {
                type: PropType<any>;
            };
            value: {
                type: PropType<any>;
            };
            disabledTime: {
                type: PropType<DisabledTime<any> & ((date: any, type: RangeType) => DisabledTimes)>;
            };
            format: {
                type: PropType<string | import("../vc-picker/interface").CustomFormat<any> | (string | import("../vc-picker/interface").CustomFormat<any>)[]>;
            };
            renderExtraFooter: {
                type: PropType<((mode: PanelMode) => VueNode) & (() => VueNode)>;
            };
            onChange: {
                type: PropType<((value: any, dateString: string) => void) & ((value: [any, any] | [string, string], dateString: [string, string]) => void)>;
            };
            'onUpdate:value': {
                type: PropType<((value: any) => void) & ((value: [any, any] | [string, string]) => void)>;
            };
            onOk: {
                type: PropType<((value: any) => void) & ((dates: [any, any] | [string, string]) => void)>;
            };
            code: StringConstructor;
            hisUuid: StringConstructor;
            domain: StringConstructor;
            config: PropType<Config>;
            onConfigChange: PropType<(config: Config) => void>;
            'onUpdate:configValue': PropType<(config: Config) => void>;
            pickerClassName: StringConstructor;
            allowEmpty: {
                type: PropType<[boolean, boolean]>;
            };
            dateRender: {
                type: PropType<import("../vc-picker/RangePicker").RangeDateRender<unknown>>;
            };
            disabled: {
                type: PropType<boolean | [boolean, boolean]>;
            };
            separator: {
                type: StringConstructor;
            };
            ranges: {
                type: PropType<Record<string, [unknown, unknown] | (() => [unknown, unknown])>>;
            };
            placeholder: ArrayConstructor;
            mode: {
                type: PropType<[PanelMode, PanelMode]>;
            };
            onCalendarChange: {
                type: PropType<(values: [string, string] | [unknown, unknown], formatString: [string, string], info: import("../vc-picker/RangePicker").RangeInfo) => void>;
            };
            onPanelChange: {
                type: PropType<(values: [string, string] | [unknown, unknown], modes: [PanelMode, PanelMode]) => void>;
            };
            showNow: {
                type: BooleanConstructor;
                default: any;
            };
            monthCellRender: {
                type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
            };
            monthCellContentRender: {
                type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
            };
            id: StringConstructor;
            dropdownClassName: StringConstructor;
            dropdownAlign: {
                type: PropType<import("../vc-align/interface").AlignType>;
            };
            popupStyle: {
                type: PropType<import("vue").CSSProperties>;
            };
            transitionName: StringConstructor;
            allowClear: {
                type: BooleanConstructor;
                default: any;
            };
            autofocus: {
                type: BooleanConstructor;
                default: any;
            };
            focusValue: {
                type: BooleanConstructor;
                default: any;
            };
            tabindex: NumberConstructor;
            open: {
                type: BooleanConstructor;
                default: any;
            };
            defaultOpen: {
                type: BooleanConstructor;
                default: any;
            };
            inputReadOnly: {
                type: BooleanConstructor;
                default: any;
            };
            getPopupContainer: {
                type: PropType<(node: HTMLElement) => HTMLElement>;
            };
            panelRender: {
                type: PropType<(originPanel: VueNode) => VueNode>;
            };
            onOpenChange: {
                type: PropType<(open: boolean) => void>;
            };
            'onUpdate:open': {
                type: PropType<(open: boolean) => void>;
            };
            onFocus: {
                type: PropType<import("../_util/EventInterface").FocusEventHandler>;
            };
            onBlur: {
                type: PropType<import("../_util/EventInterface").FocusEventHandler>;
            };
            onMousedown: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseup: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseenter: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onMouseleave: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onClick: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onContextmenu: {
                type: PropType<import("../_util/EventInterface").MouseEventHandler>;
            };
            onKeydown: {
                type: PropType<(event: KeyboardEvent, preventDefault: () => void) => void>;
            };
            role: StringConstructor;
            name: StringConstructor;
            autocomplete: StringConstructor;
            direction: {
                type: PropType<"ltr" | "rtl">;
            };
            showToday: {
                type: BooleanConstructor;
                default: any;
            };
            showTime: {
                type: PropType<boolean | import("../vc-picker/panels/TimePanel").SharedTimeProps<any>>;
                default: any;
            };
            locale: {
                type: PropType<import("../date-picker/generatePicker").PickerLocale>;
            };
            size: {
                type: PropType<import("../config-provider").SizeType>;
            };
            bordered: {
                type: BooleanConstructor;
                default: any;
            };
            disabledDate: {
                type: PropType<(date: any) => boolean>;
            };
            picker: {
                type: PropType<PickerMode>;
            };
            valueFormat: StringConstructor;
            disabledHours: PropType<() => number[]>;
            disabledMinutes: PropType<(hour: number) => number[]>;
            disabledSeconds: PropType<(hour: number, minute: number) => number[]>;
        }>>, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
            open: boolean;
            autofocus: boolean;
            showTime: any;
            showNow: boolean;
            focusValue: boolean;
            showToday: boolean;
            allowClear: boolean;
            defaultOpen: boolean;
            inputReadOnly: boolean;
            bordered: boolean;
        }, {}, string> & {
            beforeCreate?: (() => void) | (() => void)[];
            created?: (() => void) | (() => void)[];
            beforeMount?: (() => void) | (() => void)[];
            mounted?: (() => void) | (() => void)[];
            beforeUpdate?: (() => void) | (() => void)[];
            updated?: (() => void) | (() => void)[];
            activated?: (() => void) | (() => void)[];
            deactivated?: (() => void) | (() => void)[];
            beforeDestroy?: (() => void) | (() => void)[];
            beforeUnmount?: (() => void) | (() => void)[];
            destroyed?: (() => void) | (() => void)[];
            unmounted?: (() => void) | (() => void)[];
            renderTracked?: ((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[];
            renderTriggered?: ((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[];
            errorCaptured?: ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}>, info: string) => boolean | void)[];
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean>): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<{
        defaultPickerValue: {
            type: PropType<any>;
        };
        defaultValue: {
            type: PropType<any>;
        };
        value: {
            type: PropType<any>;
        };
        disabledTime: {
            type: PropType<DisabledTime<any> & ((date: any, type: RangeType) => DisabledTimes)>;
        };
        format: {
            type: PropType<string | import("../vc-picker/interface").CustomFormat<any> | (string | import("../vc-picker/interface").CustomFormat<any>)[]>;
        };
        renderExtraFooter: {
            type: PropType<((mode: PanelMode) => VueNode) & (() => VueNode)>;
        };
        onChange: {
            type: PropType<((value: any, dateString: string) => void) & ((value: [any, any] | [string, string], dateString: [string, string]) => void)>;
        };
        'onUpdate:value': {
            type: PropType<((value: any) => void) & ((value: [any, any] | [string, string]) => void)>;
        };
        onOk: {
            type: PropType<((value: any) => void) & ((dates: [any, any] | [string, string]) => void)>;
        };
        code: StringConstructor;
        hisUuid: StringConstructor;
        domain: StringConstructor;
        config: PropType<Config>;
        onConfigChange: PropType<(config: Config) => void>;
        'onUpdate:configValue': PropType<(config: Config) => void>;
        pickerClassName: StringConstructor;
        allowEmpty: {
            type: PropType<[boolean, boolean]>;
        };
        dateRender: {
            type: PropType<import("../vc-picker/RangePicker").RangeDateRender<unknown>>;
        };
        disabled: {
            type: PropType<boolean | [boolean, boolean]>;
        };
        separator: {
            type: StringConstructor;
        };
        ranges: {
            type: PropType<Record<string, [unknown, unknown] | (() => [unknown, unknown])>>;
        };
        placeholder: ArrayConstructor;
        mode: {
            type: PropType<[PanelMode, PanelMode]>;
        };
        onCalendarChange: {
            type: PropType<(values: [string, string] | [unknown, unknown], formatString: [string, string], info: import("../vc-picker/RangePicker").RangeInfo) => void>;
        };
        onPanelChange: {
            type: PropType<(values: [string, string] | [unknown, unknown], modes: [PanelMode, PanelMode]) => void>;
        };
        showNow: {
            type: BooleanConstructor;
            default: any;
        };
        monthCellRender: {
            type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
        };
        monthCellContentRender: {
            type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
        };
        id: StringConstructor;
        dropdownClassName: StringConstructor;
        dropdownAlign: {
            type: PropType<import("../vc-align/interface").AlignType>;
        };
        popupStyle: {
            type: PropType<import("vue").CSSProperties>;
        };
        transitionName: StringConstructor;
        allowClear: {
            type: BooleanConstructor;
            default: any;
        };
        autofocus: {
            type: BooleanConstructor;
            default: any;
        };
        focusValue: {
            type: BooleanConstructor;
            default: any;
        };
        tabindex: NumberConstructor;
        open: {
            type: BooleanConstructor;
            default: any;
        };
        defaultOpen: {
            type: BooleanConstructor;
            default: any;
        };
        inputReadOnly: {
            type: BooleanConstructor;
            default: any;
        };
        getPopupContainer: {
            type: PropType<(node: HTMLElement) => HTMLElement>;
        };
        panelRender: {
            type: PropType<(originPanel: VueNode) => VueNode>;
        };
        onOpenChange: {
            type: PropType<(open: boolean) => void>;
        };
        'onUpdate:open': {
            type: PropType<(open: boolean) => void>;
        };
        onFocus: {
            type: PropType<import("../_util/EventInterface").FocusEventHandler>;
        };
        onBlur: {
            type: PropType<import("../_util/EventInterface").FocusEventHandler>;
        };
        onMousedown: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onMouseup: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onMouseenter: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onMouseleave: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onClick: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onContextmenu: {
            type: PropType<import("../_util/EventInterface").MouseEventHandler>;
        };
        onKeydown: {
            type: PropType<(event: KeyboardEvent, preventDefault: () => void) => void>;
        };
        role: StringConstructor;
        name: StringConstructor;
        autocomplete: StringConstructor;
        direction: {
            type: PropType<"ltr" | "rtl">;
        };
        showToday: {
            type: BooleanConstructor;
            default: any;
        };
        showTime: {
            type: PropType<boolean | import("../vc-picker/panels/TimePanel").SharedTimeProps<any>>;
            default: any;
        };
        locale: {
            type: PropType<import("../date-picker/generatePicker").PickerLocale>;
        };
        size: {
            type: PropType<import("../config-provider").SizeType>;
        };
        bordered: {
            type: BooleanConstructor;
            default: any;
        };
        disabledDate: {
            type: PropType<(date: any) => boolean>;
        };
        picker: {
            type: PropType<PickerMode>;
        };
        valueFormat: StringConstructor;
        disabledHours: PropType<() => number[]>;
        disabledMinutes: PropType<(hour: number) => number[]>;
        disabledSeconds: PropType<(hour: number, minute: number) => number[]>;
    }>> & import("vue").ShallowUnwrapRef<() => JSX.Element> & {} & import("vue").ComponentCustomProperties & {};
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
} & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
    defaultPickerValue: {
        type: PropType<any>;
    };
    defaultValue: {
        type: PropType<any>;
    };
    value: {
        type: PropType<any>;
    };
    disabledTime: {
        type: PropType<DisabledTime<any> & ((date: any, type: RangeType) => DisabledTimes)>;
    };
    format: {
        type: PropType<string | import("../vc-picker/interface").CustomFormat<any> | (string | import("../vc-picker/interface").CustomFormat<any>)[]>;
    };
    renderExtraFooter: {
        type: PropType<((mode: PanelMode) => VueNode) & (() => VueNode)>;
    };
    onChange: {
        type: PropType<((value: any, dateString: string) => void) & ((value: [any, any] | [string, string], dateString: [string, string]) => void)>;
    };
    'onUpdate:value': {
        type: PropType<((value: any) => void) & ((value: [any, any] | [string, string]) => void)>;
    };
    onOk: {
        type: PropType<((value: any) => void) & ((dates: [any, any] | [string, string]) => void)>;
    };
    code: StringConstructor;
    hisUuid: StringConstructor;
    domain: StringConstructor;
    config: PropType<Config>;
    onConfigChange: PropType<(config: Config) => void>;
    'onUpdate:configValue': PropType<(config: Config) => void>;
    pickerClassName: StringConstructor;
    allowEmpty: {
        type: PropType<[boolean, boolean]>;
    };
    dateRender: {
        type: PropType<import("../vc-picker/RangePicker").RangeDateRender<unknown>>;
    };
    disabled: {
        type: PropType<boolean | [boolean, boolean]>;
    };
    separator: {
        type: StringConstructor;
    };
    ranges: {
        type: PropType<Record<string, [unknown, unknown] | (() => [unknown, unknown])>>;
    };
    placeholder: ArrayConstructor;
    mode: {
        type: PropType<[PanelMode, PanelMode]>;
    };
    onCalendarChange: {
        type: PropType<(values: [string, string] | [unknown, unknown], formatString: [string, string], info: import("../vc-picker/RangePicker").RangeInfo) => void>;
    };
    onPanelChange: {
        type: PropType<(values: [string, string] | [unknown, unknown], modes: [PanelMode, PanelMode]) => void>;
    };
    showNow: {
        type: BooleanConstructor;
        default: any;
    };
    monthCellRender: {
        type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
    };
    monthCellContentRender: {
        type: PropType<import("../vc-picker/panels/MonthPanel/MonthBody").MonthCellRender<any>>;
    };
    id: StringConstructor;
    dropdownClassName: StringConstructor;
    dropdownAlign: {
        type: PropType<import("../vc-align/interface").AlignType>;
    };
    popupStyle: {
        type: PropType<import("vue").CSSProperties>;
    };
    transitionName: StringConstructor;
    allowClear: {
        type: BooleanConstructor;
        default: any;
    };
    autofocus: {
        type: BooleanConstructor;
        default: any;
    };
    focusValue: {
        type: BooleanConstructor;
        default: any;
    };
    tabindex: NumberConstructor;
    open: {
        type: BooleanConstructor;
        default: any;
    };
    defaultOpen: {
        type: BooleanConstructor;
        default: any;
    };
    inputReadOnly: {
        type: BooleanConstructor;
        default: any;
    };
    getPopupContainer: {
        type: PropType<(node: HTMLElement) => HTMLElement>;
    };
    panelRender: {
        type: PropType<(originPanel: VueNode) => VueNode>;
    };
    onOpenChange: {
        type: PropType<(open: boolean) => void>;
    };
    'onUpdate:open': {
        type: PropType<(open: boolean) => void>;
    };
    onFocus: {
        type: PropType<import("../_util/EventInterface").FocusEventHandler>;
    };
    onBlur: {
        type: PropType<import("../_util/EventInterface").FocusEventHandler>;
    };
    onMousedown: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onMouseup: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onMouseenter: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onMouseleave: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onClick: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onContextmenu: {
        type: PropType<import("../_util/EventInterface").MouseEventHandler>;
    };
    onKeydown: {
        type: PropType<(event: KeyboardEvent, preventDefault: () => void) => void>;
    };
    role: StringConstructor;
    name: StringConstructor;
    autocomplete: StringConstructor;
    direction: {
        type: PropType<"ltr" | "rtl">;
    };
    showToday: {
        type: BooleanConstructor;
        default: any;
    };
    showTime: {
        type: PropType<boolean | import("../vc-picker/panels/TimePanel").SharedTimeProps<any>>;
        default: any;
    };
    locale: {
        type: PropType<import("../date-picker/generatePicker").PickerLocale>;
    };
    size: {
        type: PropType<import("../config-provider").SizeType>;
    };
    bordered: {
        type: BooleanConstructor;
        default: any;
    };
    disabledDate: {
        type: PropType<(date: any) => boolean>;
    };
    picker: {
        type: PropType<PickerMode>;
    };
    valueFormat: StringConstructor;
    disabledHours: PropType<() => number[]>;
    disabledMinutes: PropType<(hour: number) => number[]>;
    disabledSeconds: PropType<(hour: number, minute: number) => number[]>;
}>>, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    open: boolean;
    autofocus: boolean;
    showTime: any;
    showNow: boolean;
    focusValue: boolean;
    showToday: boolean;
    allowClear: boolean;
    defaultOpen: boolean;
    inputReadOnly: boolean;
    bordered: boolean;
}, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & import("@vue/runtime-core").Plugin;
export default _default;
